<template>
  <LayoutVue container="">
    <Welcome />
    <section
      id="section-thematiques"
      class="section section-grey custom-container"
    >
      <div class="block">
        <p class="card-section-header title">Quelques Indicateurs</p>
        <div class="grid is-hidden-mobile px-6 mx-5">
          <div class="card mr-3">
            <Analytic :indice-name="center + ' Centres'" icon="location.svg" />
          </div>
          <div class="card ml-3">
            <Analytic
              :indice-name="
                $options.filters.toPercent(supplySatisfactionRate) +
                ' de taux de satisfaction d\'approvisionnement'
              "
              icon="truck.svg"
            />
          </div>
          <div class="card mr-3">
            <Analytic
              :indice-name="
                $options.filters.formatNumber(averageStockOut) +
                ' jours en moyenne de rupture de stocks'
              "
              icon="duration.svg"
            />
          </div>
          <div class="card ml-3">
            <Analytic
              :indice-name="
                $options.filters.toPercent(expiredProductRate) +
                ' de taux de produits périmés'
              "
              icon="perime.svg"
            />
          </div>
        </div>
      </div>
      <b-carousel class="is-hidden-tablet">
        <b-carousel-item>
          <section :class="`hero is-medium `">
            <div class="hero-body has-text-centered">
              <Analytic
                :indice-name="`${center} Centres`"
                icon="location.svg"
              />
            </div>
          </section>
        </b-carousel-item>
        <b-carousel-item>
          <section :class="`hero is-medium `">
            <div class="hero-body has-text-centered">
              <Analytic
                :indice-name="
                  $options.filters.toPercent(supplySatisfactionRate) +
                  ' de taux de satisfaction d\'approvisionnement'
                "
                icon="truck.svg"
              />
            </div>
          </section>
        </b-carousel-item>
        <b-carousel-item>
          <section :class="`hero is-medium `">
            <div class="hero-body has-text-centered">
              <Analytic
                :indice-name="
                  $options.filters.formatNumber(averageStockOut) +
                  ' jours en moyenne de rupture de stocks'
                "
                icon="duration.svg"
              />
            </div>
          </section>
        </b-carousel-item>
        <b-carousel-item>
          <section :class="`hero is-medium `">
            <div class="hero-body has-text-centered">
              <Analytic
                :indice-name="
                  $options.filters.toPercent(expiredProductRate) +
                  ' de taux de produits périmés'
                "
                icon="perime.svg"
              />
            </div>
          </section>
        </b-carousel-item>
      </b-carousel>
      <div class="infos" style="margin-top: 5%">
        <p>Pour plus d'informations, <a href="#stats">cliquez ici</a></p>
      </div>
    </section>
    <Partner />
    <Statistique id="stats" />
  </LayoutVue>
</template>

<script>
import axios from 'axios';

import Analytic from '~/components/Analytic.vue';
import Partner from '~/components/Partner.vue';
import Statistique from '~/components/Statistique.vue';
import Welcome from '~/components/Welcome.vue';

export default {
  name: 'IndexPage',
  components: {
    Welcome,
    Partner,
    Statistique,
    Analytic,
  },
  metaInfo: {
    title: 'Accueil',
  },
  filters: {
    // Filter definitions
    toPercent(value) {
      return `${value.toLocaleString()}%`;
    },
    formatNumber(value) {
      return `${value.toLocaleString()}`;
    },
  },
  data() {
    return {
      recapData: {
        centres: {
          cameroun: 0,
          burkina: 0,
        },
        taux_approvisionnement: {
          cameroun: 0,
          burkina: 0,
        },
        duree_moyenne: {
          cameroun: 0,
          burkina: 0,
        },
        taux_peremption: {
          cameroun: 0,
          burkina: 0,
        },
      },
      isSubcategorie: false,
    };
  },
  computed: {
    center() {
      return this.recapData.centres.cameroun + this.recapData.centres.burkina;
    },
    supplySatisfactionRate() {
      return (
        (this.recapData.taux_approvisionnement.cameroun +
          this.recapData.taux_approvisionnement.burkina) /
        2
      );
    },
    averageStockOut() {
      return (
        (this.recapData.duree_moyenne.cameroun +
          this.recapData.duree_moyenne.burkina) /
        2
      );
    },
    expiredProductRate() {
      return (
        (this.recapData.taux_peremption.cameroun +
          this.recapData.taux_peremption.burkina) /
        2
      );
    },
  },
  async mounted() {
    axios
      .post(
        `${process.env.GRIDSOME_ELASTICSEARCH_CAMEROUN}`,
        this.$elasticSearch.cameroun
      )
      .then((response) => {
        this.recapData.duree_moyenne.cameroun =
          response.data.aggregations.average_out_of_stock_duration.value;
        this.recapData.centres.cameroun =
          response.data.aggregations.center_count.value;
        if (response.data.hits.total.value !== 0) {
          this.recapData.taux_approvisionnement.cameroun =
            (100 *
              response.data.aggregations.taux_approvisionnement.doc_count) /
            response.data.hits.total.value;
          this.recapData.taux_peremption.cameroun =
            (100 * response.data.aggregations.taux_peremption.doc_count) /
            response.data.hits.total.value;
        }
      })
      .catch(() => {
        this.recapData.duree_moyenne.cameroun = 0;
        this.recapData.centres.cameroun = 0;
        this.recapData.taux_approvisionnement.cameroun = 0;
        this.recapData.taux_peremption.cameroun = 0;
      });
    axios
      .post(
        `${process.env.GRIDSOME_ELASTICSEARCH_BURKINA_FASO}`,
        this.$elasticSearch.burkina
      )
      .then((res) => {
        const response = res.data;
        if (response.aggregations.ruptures.value !== 0) {
          this.recapData.duree_moyenne.burkina =
            response.aggregations.out_stocks_times.value /
            response.aggregations.ruptures.value /
            (60 * 60 * 24);
        }
        this.recapData.centres.burkina = response.aggregations.centers.value;
        if (response.aggregations.asked.value !== 0) {
          this.recapData.taux_approvisionnement.burkina =
            (100 * response.aggregations.received.value) /
            response.aggregations.asked.value;
        }
        const stock =
          response.aggregations.init.value +
          response.aggregations.received.value;
        if (stock !== 0) {
          const spoil =
            response.aggregations.expired.value +
            response.aggregations.spoiled.value;
          this.recapData.taux_peremption.burkina = (100 * spoil) / stock;
        }
      })
      .catch(() => {
        this.recapData.duree_moyenne.burkina = 0;
        this.recapData.centres.burkina = 0;
        this.recapData.taux_approvisionnement.burkina = 0;
        this.recapData.taux_peremption.burkina = 0;
      });
  },
};
</script>

<style>
@media only screen and (min-width: 1024px) {
  .contentMarges {
    padding-left: 0.8em;
    padding-right: 0.8em;
  }
}
@media only screen and (max-width: 768px) {
  .card-section-header {
    text-align: center;
  }
}

@media only screen and (max-width: 415px) {
  .is-category-touch {
    margin-bottom: 2em;
  }

  .is-notif-description {
    margin-top: -4em;
  }

  .card-section-header {
    font-size: 1.7rem;
    line-height: 1.25em;
    font-family: 'Evolventa', 'lato', sans-serif;
    font-weight: bold;
  }
}
.infos {
  text-align: center;
}
.grid {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  grid-auto-rows: 1fr;
  grid-column-gap: 15px;
  grid-row-gap: 15px;
}
.hero {
  height: 320px !important;
  background-color: white;
  align-items: center;
  -webkit-box-shadow: 0 1px 2px rgba(201, 211, 223, 0.2);
  box-shadow: 0 1px 2px rgba(201, 211, 223, 0.2);
  box-shadow: var(--theme-box-shadow);
}
.hero-body {
  align-items: center;
  text-align: center;
}
.flex-center .card__content {
  justify-content: center;
  align-items: center;
  display: flex;
}
</style>
